		        TITLE JejeConex.asm
;                      by  n u M I T_o r, 2k
;              http://members.xoom.com/numit_or/asm.html


.386
.Model Flat,Stdcall

INCLUDE \MASM32\INCLUDE\Windows.Inc
INCLUDE \MASM32\INCLUDE\Kernel32.inc
INCLUDE \MASM32\INCLUDE\User32.inc
INCLUDE \MASM32\INCLUDE\Rasapi32.inc

INCLUDELIB \MASM32\LIB\Kernel32.Lib
INCLUDELIB \MASM32\LIB\User32.Lib
INCLUDELIB \MASM32\LIB\Rasapi32.Lib


.DATA
  iError     		db "Error",0
  iErrorAlloc 		db "Error de localizacin de memoria", 13, 10, 13, 10
			db "Error to alloc memory", 0
  iErrorLock 		db "Error de Bloqueo", 13, 10, 13, 10
                        db "Error to block memory", 0
  iErrorGetP 		db "Error recuperando informacin", 13, 10, 13, 10
                        db "Error getting info", 0
  iErrorSmallBuff 	db "ERROR_BUFFER_TOO_SMALL", 0
  iErrorNoBook 		db "ERROR_CANNOT_OPEN_PHONEBOOK", 0
  iErrorNoEntry 	db "ERROR_CANNOT_FIND_PHONEBOOK_ENTRY", 0
  iErrorBadBuffer 	db "ERROR_BUFFER_INVALID", 0
  iConecting 		db "Conectando - Conecting", 0
  CapStr                db "Jeje Conex...", 0

  UNStr  db  'Username: '
  UNbuff db  UNLEN dup (0)
  PWStr  db  13, 10, 'Password: '
  PWBuff db  PWLEN+2 dup (0)
  Msg01  db  13, 10, 13, 10, 'Deseas conectarte?'
         db  13, 10, 13, 10, 'Do you want to connect?', 0

  temp1  db 'Nmero de entradas: %ld', 13, 10, 13, 10
         db 'Number of entries: %ld', 0
  
.DATA?
    hInstance   dd ?
    password    dd ?
    buffer 	db UNLEN+PWLEN+4+100*2 dup (?)
    uEntriesStr db 200 dup (?) 

.CODE
Begin:
    Push 0h
    Call GetModuleHandleA
    push eax

    Call MyConnect
    
    call ExitProcess

MyConnect Proc uses esi edi ebx
    LOCAL RasCon:RASCONNA, ren:RASENTRYNAMEA
    LOCAL TrueSize:DWORD, uEntries:DWORD

    Mov RasCon.hrasconn,NULL
; -------------------------------------------------------
; Get the number of entries in a phone book
; Obtiene el nmero de entradas en la libreta telefnica
; -------------------------------------------------------
    lea esi, ren
    invoke RtlZeroMemory, esi, sizeof RASENTRYNAME
    mov dword ptr [esi], 108h
    invoke RasEnumEntries, 0, 0, esi, addr TrueSize, addr uEntries
    push eax
    xor edx, edx
    mov eax, TrueSize
    mov ecx, 108h
    div ecx
; ----------------------------------------------------------
; eax has the number of entries, display it in a messagebox
; eax tiene el nmero de entradas, desplegarlo
; ----------------------------------------------------------
    invoke wsprintf, addr uEntriesStr, addr temp1, eax, eax
    Invoke MessageBox, NULL, addr uEntriesStr, addr CapStr, MB_ICONINFORMATION
; -----------------------------------------------------------
; if there are more than 1 entry, get the name of the first
; si hay ms de una enrtada, obtener el nombre de la primera
; -----------------------------------------------------------
    pop  eax
    push eax
    .if eax==ERROR_BUFFER_TOO_SMALL
        mov ebx, TrueSize
        invoke GlobalAlloc, 0, ebx
        mov esi, eax
        invoke RtlZeroMemory, esi, ebx
        mov dword ptr [esi], 108h
    	invoke RasEnumEntries, 0, 0, esi, addr TrueSize, addr uEntries
    .endif
        push esi
        push edi
        lea  edi, ren
        mov  ecx, sizeof RASENTRYNAME
        rep  movsb
        pop  edi
        pop  esi
     pop eax
     .if eax==ERROR_BUFFER_TOO_SMALL
        invoke GlobalFree, esi
    .endif
; -----------------------------------------
; Get the data of the first entry
; Obtener  los datos de la primera entrada
; -----------------------------------------
	; -------------------------------------------------
	; Alloc and block RASDIALPARAMSA strcture
	; Localizar y bloquear la estrcutura RASDIALPARAMSA
	; -------------------------------------------------
    invoke GlobalAlloc, 0, sizeof RASDIALPARAMSA
    .IF eax==NULL
        Invoke MessageBox, NULL, ADDR iErrorAlloc, ADDR iError, 30h
        xor eax, eax
        ret
    .ENDIF
    push eax
	; ------------------------------------
	; Clean the structure buffer
	; Limpiar el buffer de la estructura
	; ------------------------------------
    mov  edi, eax
    mov  ecx, sizeof RASDIALPARAMSA
    xor  eax, eax
    rep  stosb
    pop  edi
	; ---------------------------------
	; Set the entry name
	; Poner el nombre de la estructura
	; ---------------------------------
    assume edi: ptr RASDIALPARAMSA
    mov  dword ptr [edi], 041Ch 
    invoke lstrcpy, addr [edi].szEntryName, addr ren.szEntryName
    invoke GlobalLock, edi
    .IF eax==NULL
        Invoke MessageBox,NULL,ADDR iErrorLock,ADDR iError,30h
        xor eax, eax
        ret
    .ENDIF
    mov edi, eax
	; -----------------------
	; Get the info
	; Obtener la informacin
	; -----------------------
    Invoke RasGetEntryDialParams, NULL, edi, addr password
    .IF eax==ERROR_CANNOT_OPEN_PHONEBOOK
        Invoke MessageBox,NULL,ADDR iErrorNoBook,ADDR iError,30h
    .ELSEIF eax==ERROR_CANNOT_FIND_PHONEBOOK_ENTRY
        invoke MessageBox,NULL,ADDR iErrorNoEntry,ADDR iError,30h
    .ELSEIF eax==ERROR_BUFFER_INVALID
	invoke MessageBox,NULL,ADDR iErrorBadBuffer,ADDR iError,30h
    .ELSEIF eax==0
	; -------------------------
	; Display the info
	; Desplegar la informacin
	; -------------------------
        invoke lstrcat, addr UNStr, addr [edi].szUserName
        invoke lstrcat, addr buffer, addr UNStr
        invoke lstrcat, addr PWStr, addr [edi].szPassword
        invoke lstrcat, addr buffer, addr PWStr
        invoke lstrcat, addr buffer, addr Msg01
        Invoke MessageBox,NULL, addr buffer, addr CapStr, MB_ICONINFORMATION  or MB_YESNO
	.if eax==IDYES
; -----------------------------------
; Conect with that entry
; Conectarse a travs de esa entrada
; -----------------------------------
        	Invoke RasDial, 0, NULL, edi, 0, 0, ADDR RasCon.hrasconn
        	Invoke MessageBox,NULL, addr [edi].szEntryName, addr CapStr, MB_ICONINFORMATION
        .endif       
    .ENDIF
; -------------------------------
; Free a unlock buffer
; Liberar y desbloquar el buffer
; -------------------------------
invoke GlobalUnlock, edi
invoke GlobalFree, edi
assume edi:nothing
ret
MyConnect endp
End Begin
